#include <stdio.h>
#include <stdlib.h>

#include <pth.h>

#define PTH_CALL(func, args...) \
  if (!func (args)) { \
    fprintf (stderr, #func " failed\n"); \
    exit (1); \
  }

#ifndef NUM_SWITCHES
#define NUM_SWITCHES 100
#endif

pth_uctx_t uctx_main, uctx_cth;

void 
cothread_func (void *arg)
{
  int i;

  for (i = 0; i < NUM_SWITCHES; i++) {
    //printf ("In cothread\n");
    PTH_CALL (pth_uctx_switch, uctx_cth, uctx_main);
  }
}

int
main (void)
{
  int i;

  PTH_CALL (pth_init);

  /* Create the main context. */
  PTH_CALL (pth_uctx_create, &uctx_main);

  /* Create the cothread context. */
  PTH_CALL (pth_uctx_create, &uctx_cth);
  PTH_CALL (pth_uctx_make, uctx_cth, NULL, 32 * 1024, NULL,
      cothread_func, NULL, uctx_main);

  for (i = 0; i < NUM_SWITCHES; i++) {
    //printf ("In main\n");
    PTH_CALL (pth_uctx_switch, uctx_main, uctx_cth);
  }

  PTH_CALL (pth_uctx_destroy, uctx_main);
  PTH_CALL (pth_uctx_destroy, uctx_cth);

  PTH_CALL (pth_kill);

  return 0;
}
